package com.hotwj.platform.securityManagement.accidentReport.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.securityManagement.accidentReport.domain.HotAccidentReport;
import com.hotwj.platform.securityManagement.accidentReport.domain.bo.HotAccidentReportBo;
import com.hotwj.platform.securityManagement.accidentReport.domain.vo.HotAccidentReportVo;
import com.hotwj.platform.securityManagement.accidentReport.mapper.HotAccidentReportMapper;
import com.hotwj.platform.securityManagement.accidentReport.service.IHotAccidentReportService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 事故报告Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-06
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotAccidentReportServiceImpl implements IHotAccidentReportService {

    private final HotAccidentReportMapper baseMapper;

    /**
     * 查询事故报告
     *
     * @param id 主键
     * @return 事故报告
     */
    @Override
    public HotAccidentReportVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事故报告列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事故报告分页列表
     */
    @Override
    public TableDataInfo<HotAccidentReportVo> queryPageList(HotAccidentReportBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotAccidentReport> lqw = buildQueryWrapper(bo);
        Page<HotAccidentReportVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事故报告列表
     *
     * @param bo 查询条件
     * @return 事故报告列表
     */
    @Override
    public List<HotAccidentReportVo> queryList(HotAccidentReportBo bo) {
        LambdaQueryWrapper<HotAccidentReport> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotAccidentReport> buildQueryWrapper(HotAccidentReportBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotAccidentReport> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotAccidentReport::getId);
        lqw.eq(bo.getCompanyId() != null, HotAccidentReport::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getAccidentId() != null, HotAccidentReport::getAccidentId, bo.getAccidentId());
        lqw.like(StringUtils.isNotBlank(bo.getReportName()), HotAccidentReport::getReportName, bo.getReportName());
        lqw.eq(StringUtils.isNotBlank(bo.getAttachmentUrls()), HotAccidentReport::getAttachmentUrls, bo.getAttachmentUrls());
        lqw.eq(bo.getCreateTime() != null, HotAccidentReport::getCreateTime, bo.getCreateTime());
        lqw.eq(bo.getIsDeleted() != null, HotAccidentReport::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增事故报告
     *
     * @param bo 事故报告
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotAccidentReportBo bo) {
        HotAccidentReport add = MapstructUtils.convert(bo, HotAccidentReport.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事故报告
     *
     * @param bo 事故报告
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotAccidentReportBo bo) {
        HotAccidentReport update = MapstructUtils.convert(bo, HotAccidentReport.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotAccidentReport entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事故报告信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
